/* gvSIG. Geographic Information System of the Valencian Government
 *
 * Copyright (C) 2007-2008 Infrastructures and Transports Department
 * of the Valencian Government (CIT)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 */

package org.gvsig.fortunecookies.swing;

import org.gvsig.tools.locator.BaseLocator;

public class FortuneCookieSwingLocator extends BaseLocator {

	private static final String LOCATOR_NAME = "FortuneCookie.swing.locator";
	
	public static final String UIMANAGER_NAME = "fortunecookie.swing.manager";

	public static final String UIMANAGER_DESCRIPTION = "Fortune Cookie UIManager";

	/**
	 * Unique instance.
	 */
	private static final FortuneCookieSwingLocator instance = new FortuneCookieSwingLocator();

	/**
	 * Return the singleton instance.
	 *
	 * @return the singleton instance
	 */
	public static FortuneCookieSwingLocator getInstance() {
		return instance;
	}

	/**
	 * Return the Locator's name
	 *
	 * @return a String with the Locator's name
	 */
	public String getLocatorName() {
		return LOCATOR_NAME;
	}

	/**
	 * Registers the Class implementing the PersistenceManager interface.
	 *
	 * @param clazz
	 *            implementing the PersistenceManager interface
	 */
	public static void registerUIManager(Class clazz) {
		getInstance().register(UIMANAGER_NAME, UIMANAGER_DESCRIPTION, clazz);
	}

	/**
	 * Gets the instance of the {@link ScriptingUIManager} registered.
	 *
	 * @return {@link ScriptingUIManager}
	 */
	public static FortuneCookieUIManager getUIManager() {
		return (FortuneCookieUIManager) getInstance().get(UIMANAGER_NAME);
	}

}
